; Bootsector of KOS
; version beta
; This version print a string, and detect if the proc is a 386 or +

[BITS 16]
[ORG 0]			; the code start at the beginning of the binary file

jmp start		; go to entry point

texte	db 'Loading KOS', 13, 10 ,0 ; define a text
check   db 'Checking for a 386+ processor...', 0
found386 db ' Found', 13, 10, 0
need386 db ' Not Found', 13, 10, 0

message:		; procedure which print the string pointed by ds:si
			; to screen

	lodsb		; load ds:si in al and make si++
	or al, al	; if al = 0
	jz done		; then done cause it's the end of the string
	mov ah, 0eh	; use service 0eh
	mov bx, 0007	; parameters
	int 0x10	; call to interrupt 10
	jmp message	; loop until the end of the string
done:
	ret		; return in main code

no386:
	mov si, need386
	call message
hang:
	jmp hang
	
	
start:			; entry point, the execution start here
	mov ax, 0x7C0	; put 0x7C0, the adress where is located the bootsect
	mov ds, ax	; in the memory, in ax. And put it in ds
	mov si, texte	; put the offset of the string in si
			; now texte is pointed by ds:si
	call message	; call the procedure
	mov si, check
	call message

	; detect if the process if at least a 386 ! (needed for protected mode)
	; well let's explain this "hard" procedure
	; an Intel processor have an E-flag register. This register contain
	; a lot of information. You must read byte per byte
	; we know that the bit 12 to 14 of this e-flag register can be
	; modifiable only on a 386 or sup
	; bit 12 & 13 are IOPL bits : I/O Provilege Level
	; bit 14 is NT
	; so we tried to set those bits and then chech if the modification is 
	; OK !!

	pushf			; save the flags 
	mov ah, 70h		; ah = 70h, or 0111
	push ax			; put ax onto the stack
	popf			; and move it to the flags
	pushf			; put the flags
	pop ax			; again into ax
	cmp ah, 70h		; and compare ah to 70h
	jne no386		; if not this is not a 386 proc
	popf			; restore the orginal flags

	mov si, found386	; that's a 386+ processor, cool !
	call message		; we are able to move to protected mode

.386	; now we are sure that we have a 386 processor at least
	; so we can use 386 instructions
