/************************************************************************/
/*                                                                      */
/* Name : bootsect.c                                                    */
/* Autor : Thomas Petazzoni & Giovanni A. Derks                         */
/* Last modification : 29/12/1998                                       */
/*                                                                      */
/* Description :                                                        */
/* Place un fichier de 512 octets (par ex : bootsect) sur le premier    */
/* secteur d'une disquette                                              */
/* Place un fichier de 512 octets (for ex : bootsect) on the first      */
/* sector of a floppy disk 												*/
/************************************************************************/


#include <bios.h>		/* for the biosdisk function */
#include <stdio.h>      /* for printf... */
#include <process.h>    /* for the exit function */
#include <conio.h>		/* for getch and clrscr */

void main(int argc, char *argv[])

{

	FILE *in;     				/* file of 512 bytes */
	int result;                 /* used for error detection */
	unsigned char buffer[520];  /* buffer to load the file */
	clrscr();                   /* clear screen */

	if (argc != 2)              /* this program need two arguments */
								/* if not -> show a help */
		{
		printf("\nUtilisation : bootsect image\n");
		printf("Ou image est un fichier de 512 octets  placer sur le premier secteur de la \ndisquette\n");

		printf("\nUsage : bootsect image\n");
		printf("Where image is a file, which is 512 bytes in size, to be placed on the first \nsector of the floppy\n");
		exit(1);
		}


	if ((in = fopen(argv[1], "rb"))==NULL) /* open the 512 bytes file */

	{
		printf("Error loading file\n");
		printf("Erreur de chargement du fichier\n");
		exit(1);

	}
	printf("\nPlease insert a floppy disk in the drive A: and press <Space>");
	printf("\nVeuillez insrer une disquette dans le lecteur A: et appuyer sur <Espace>");
	getch();
	fread(&buffer, 512, 1, in);		/* read the 512 bytes file */
	printf("\n\nTesting if the drive is ready...");
	printf("\nTeste si le lecteur est prt...\n");

	result = biosdisk(4, 0, 0, 0, 0, 1, buffer);   /* testing for drive ready */
	if ((result == 6) | (result == 4))
		{
		printf("\nDrive ready !");
		printf("\nLecteur prt !\n");
		}
	else
		{
		printf("\nDrive not ready");
		printf("\nLecteur non prt\n");
		exit(1);                                 /* if not -> exit */
		}
	printf("\nStarting writing...");
	biosdisk(3, 0, 0, 0, 1, 1, buffer);          /* write the 512 bytes file */
	printf("Done\n");
	printf("\nBye !");
	fclose(in);


}

