/************************************************************************/
/*                                                                      */
/* Nom : mkboot.c                                                       */
/* Auteur : Thomas Petazzoni                                            */
/* Dernire modification : 13/12/1998                                   */
/*                                                                      */
/* Description :                                                        */
/* Lit un fichier .com, le remplit d'instruction NOP jusqu' temps que  */
/* sa taille soit de 510 octets, puis place le magic number  la fin    */
/************************************************************************/


#include <stdio.h>
#include <process.h>

int makeboot(char *oldname, char *newname);
int count;

void main(int argc, char *argv[])

{

	if(argc != 3)
	{

	printf("\nUsage : mkboot src dest");
	printf("\nWhere src is a binary file, and dest is a file which will be \n512 bytes in size");
	printf("\nThis program has been made to transform a binary file to a valid bootsector\n");
	printf("\nUtilisation : mkboot src dest");
	printf("\nOu src est un fichier binaire et dest est un fichier qui sera de 512 octets");
	printf("\nCe programmea ete cree pour transformer un fichier binaire en un bootsecteur \nvalide\n");
	exit(1);
	}

	if(makeboot(argv[1], argv[2]) == 0)
		{		
			puts("\nOperation reussie");
			puts("Operation complete");
		}
	else
		{
		fprintf(stderr, "\nError !");
		fprintf(stderr, "\nErreur !");
		exit(1);
		}
}

int makeboot(char *oldname, char *newname)

{
	int count = 0;
	FILE *fold, *fnew;
	int c;

	if((fold = fopen(oldname, "rb")) == NULL)
		return -1;

	if((fnew = fopen(newname, "wb")) == NULL)
	{
		fclose(fold);
		return -1;
	}

while (1)
{

	c=fgetc(fold);

	if(!feof(fold))
		{

		fputc(c, fnew);
		count++;
		}
	else
		break;

}

c = 144;

for (count=count; count < 510; count++)

{


	fputc(c, fnew);
}

c = 170;
fputc(c, fnew);
c = 85;
fputc(c, fnew);
fclose(fnew);
fclose(fold);
return 0;

}
